
void _efl_canvas_gesture_state_set(Eo *obj, Efl_Canvas_Gesture_Data *pd, Efl_Canvas_Gesture_State state);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gesture_state_set, EFL_FUNC_CALL(state), Efl_Canvas_Gesture_State state);

Efl_Canvas_Gesture_State _efl_canvas_gesture_state_get(const Eo *obj, Efl_Canvas_Gesture_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_state_get, Efl_Canvas_Gesture_State, 0);

void _efl_canvas_gesture_hotspot_set(Eo *obj, Efl_Canvas_Gesture_Data *pd, Eina_Position2D hotspot);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gesture_hotspot_set, EFL_FUNC_CALL(hotspot), Eina_Position2D hotspot);

Eina_Position2D _efl_canvas_gesture_hotspot_get(const Eo *obj, Efl_Canvas_Gesture_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_hotspot_get, Eina_Position2D, ((Eina_Position2D){0}));

void _efl_canvas_gesture_timestamp_set(Eo *obj, Efl_Canvas_Gesture_Data *pd, unsigned int timestamp);


static Eina_Error
__eolian_efl_canvas_gesture_timestamp_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   unsigned int cval;
   if (!eina_value_uint_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gesture_timestamp_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gesture_timestamp_set, EFL_FUNC_CALL(timestamp), unsigned int timestamp);

unsigned int _efl_canvas_gesture_timestamp_get(const Eo *obj, Efl_Canvas_Gesture_Data *pd);


static Eina_Value
__eolian_efl_canvas_gesture_timestamp_get_reflect(const Eo *obj)
{
   unsigned int val = efl_gesture_timestamp_get(obj);
   return eina_value_uint_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_timestamp_get, unsigned int, 0);

void _efl_canvas_gesture_touch_count_set(Eo *obj, Efl_Canvas_Gesture_Data *pd, unsigned int touch_count);


static Eina_Error
__eolian_efl_canvas_gesture_touch_count_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   unsigned int cval;
   if (!eina_value_uint_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gesture_touch_count_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_gesture_touch_count_set, EFL_FUNC_CALL(touch_count), unsigned int touch_count);

unsigned int _efl_canvas_gesture_touch_count_get(const Eo *obj, Efl_Canvas_Gesture_Data *pd);


static Eina_Value
__eolian_efl_canvas_gesture_touch_count_get_reflect(const Eo *obj)
{
   unsigned int val = efl_gesture_touch_count_get(obj);
   return eina_value_uint_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_gesture_touch_count_get, unsigned int, 0);

static Eina_Bool
_efl_canvas_gesture_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_GESTURE_EXTRA_OPS
#define EFL_CANVAS_GESTURE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gesture_state_set, _efl_canvas_gesture_state_set),
      EFL_OBJECT_OP_FUNC(efl_gesture_state_get, _efl_canvas_gesture_state_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_hotspot_set, _efl_canvas_gesture_hotspot_set),
      EFL_OBJECT_OP_FUNC(efl_gesture_hotspot_get, _efl_canvas_gesture_hotspot_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_timestamp_set, _efl_canvas_gesture_timestamp_set),
      EFL_OBJECT_OP_FUNC(efl_gesture_timestamp_get, _efl_canvas_gesture_timestamp_get),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_count_set, _efl_canvas_gesture_touch_count_set),
      EFL_OBJECT_OP_FUNC(efl_gesture_touch_count_get, _efl_canvas_gesture_touch_count_get),
      EFL_CANVAS_GESTURE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"timestamp", __eolian_efl_canvas_gesture_timestamp_set_reflect, __eolian_efl_canvas_gesture_timestamp_get_reflect},
      {"touch_count", __eolian_efl_canvas_gesture_touch_count_set_reflect, __eolian_efl_canvas_gesture_touch_count_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_gesture_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Gesture",
   EFL_CLASS_TYPE_REGULAR_NO_INSTANT,
   sizeof(Efl_Canvas_Gesture_Data),
   _efl_canvas_gesture_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_gesture_class_get, &_efl_canvas_gesture_class_desc, EFL_OBJECT_CLASS, NULL);
